testLocal = false

sessions_js = {"sessions" : []}

make_base_auth = (user, password) ->
	tok = user + ":" + password
	hash = btoa(tok)
	"Basic " + hash

saved_sessions = []

Strongspace.SessionSync = (method, model, options) ->

	switch method

		when "read"
			session_array = []
			try
				to_parse = file.reader()
				if to_parse and to_parse.length > 1
					parsed_sessions = JSON.parse(to_parse)
					if parsed_sessions.constructor == Object
						# upgrade from v2 format
						parsed_sessions = parsed_sessions['drives']
						file.writer(JSON.stringify(parsed_sessions))
						to_parse = file.reader()
						parsed_sessions = JSON.parse(to_parse)
				else
					parsed_sessions = []

				
				for session in parsed_sessions
					if session['id'] == undefined
						id = ""
						id += Math.random().toString(36).substr(2) while id.length < 8
						id.substr 0, 8
						session['id'] = id

					if session['status'] != undefined
						delete session['status']

					if session['driveType'] != undefined
						session['type'] = session['driveType']
						delete session['driveType']

					if session['type'] == "Amazon S3"
						session['type'] = "s3"
				
					session['type'] = session['type'].toLowerCase()

					if session['name'] == undefined
						session['name'] = session['type']
						if session['server'] != undefined
							session['name'] = session['server']
					session_array.push(session)
			finally
				options.success(model, session_array, options)

		when "create"
			session_array = []
			
			model['id'] = model.uniqueId()
			model.set('id', model['id'])

			session_array.push(model.attributes)

			for session in Strongspace.SavedSessions.models
				session_array.push(session.cleanJSON())
			
			if model.get('reconnectAtLogon') == true
				loginitem.setLaunchAtLogon(true)

			file.writer(JSON.stringify(session_array))
			options.success(model, model.cleanJSON(), options)

		when "update"
			session_array = []
			for session in Strongspace.SavedSessions.models				
				session_array.push(session.cleanJSON())

			if model.get('reconnectAtLogon') == true
				loginitem.setLaunchAtLogon(true)

			file.writer(JSON.stringify(session_array))
			options.success(model, model.cleanJSON(), options)

		when "delete"
			session_array = []
			for session in Strongspace.SavedSessions.models
				if session.id != model.id
					session_array.push(session.cleanJSON())
			file.writer(JSON.stringify(session_array))
			options.success(model, model.cleanJSON(), options)
			
Backbone.sync = Strongspace.SessionSync
