window.dlog = (message) ->
	console.log message

window.session_array = []

window.activity = (activityString) ->
	model = Strongspace.SavedSessions.get(activityString.split(":")[2])
	model.activity(activityString)


Backbone.Layout.configure
	manage: true
	fetch: (name) ->
		return new window.EJS {url: "javascripts/templates/" + name + ".ejs"}

	render: (template, context) ->
		return template.render(context)
window.testing = false

window.Strongspace =
	Models: {}
	Collections: {}
	Views: {}
	Routers: {}
	
	SessionSync: null
	SavedSessions: null
	Popover: null
	Sidebar: null
	List: null
	Settings: null
	Layout: null
	Details: null

	initialize: () ->
		self = @
		if window.testing == false
			$("body").attr("oncontextmenu", "return false")

		if settings.platform() == "mac"
			$("#windows-stylesheet").remove()

		Strongspace.Settings = {}
		Strongspace.Settings["more_options"] = false
		Strongspace.Settings["selected"] = null

		Strongspace.List = new Strongspace.Views.List(template: "list")
		Strongspace.Sidebar = new Strongspace.Views.Sidebar(template: "sidebar")
		Strongspace.Settings = new Strongspace.Views.Settings(template: "settings")

		Strongspace.Layout = new Backbone.Layout(
			template: "layout"
			views:
				"#sidebar": Strongspace.Sidebar
				"#content": Strongspace.List
				"#settings" : Strongspace.Settings
		)


		Strongspace.Layout.$el.appendTo("#app");

		Strongspace.Layout.render()

		document.title = 'ExpanDrive 3'

		$("select").blur()

		today = new Date()
		expiration = new Date()
		expiration.setFullYear(2013, 4, 11)

		if today > expiration
			setTimeout ( ->
				 $("li.settings").click()
				 $("#sidebar li").hide()
				 alert "This development release has expired, please update to a newer version"
			), 100
		else
			setTimeout ( ->
				if loginitem.launchedAtLogon()
					Strongspace.SavedSessions.startAllForLogon()
			), 1000

	
	collapseListifNecessary: () ->
		if $(window).width() < 600 and ($("#settings").position().left < 0 and !$("#sidebar li.active").hasClass("new"))
			$("#details").hide()
			$("#sessions").data("orig_width", $("#sessions").width())
			$("#sessions").width(450)
		else if $("#settings").position().left < 0
			$("#details").show()
			$("#sessions").width($("#sessions").data("orig_width"))
		
	applicationShouldterminate: () ->
		#alert "Term"
		Strongspace.SavedSessions.stopAll()
		return true

	startAll: () ->
#		alert "Startall"
		Strongspace.SavedSessions.startAll()

	stopAll: () ->
		Strongspace.SavedSessions.stopAll()
	
	startActivity: (id) ->
		@saved_sessions.startActivity(id)

	stopActivity: (id) ->
		@saved_sessions.stopActivity(id)

	removeSession: (id) ->
		model = Strongspace.SavedSessions.get(id)
		model.stop()
		Strongspace.SavedSessions.remove(model)
		model.destroy()
		Strongspace.List.render()

	listSessions: () ->
		ret =  "=== Available drives\n"
		for session in Strongspace.SavedSessions.models
			ret += session.get("name") + "\n"

		return ret

	connectSession: (id) ->
		model = Strongspace.SavedSessions.get(id)

		if model == undefined
			for session in Strongspace.SavedSessions.models
				if session.get("name") == id
					model = session
					break
		if model == undefined
			return "#{id} is an invalid drive\n"

		if not (model.get('status') == "connected" or model.get('status') == "connecting")
			model.start()
		if model.get('status') == "connected"
			model.reveal()
		return "Connecting #{id}\n"

	ejectSession: (id) ->

		model = Strongspace.SavedSessions.get(id)
		if model == undefined
			for session in Strongspace.SavedSessions.models
				if session.get("name") == id
					model = session
					break
		if model == undefined
			return "#{id} is an invalid drive\n"
			
		model.eject()

		return "Ejected #{id}\n"

	newSession: () ->
		$("li.new").click()


	showSettings: () ->
		$("li.settings").click()

	revealSession: (id) ->
		model = Strongspace.SavedSessions.get(id)
		model.reveal()

	sendMessage: (id, message) ->
		model = Strongspace.SavedSessions.get(id)
		model.activity(message)

	inputKey: (keyString) ->
		alert keyString

	getDriveArray: () ->
		return JSON.stringify(Strongspace.SavedSessions.models)
