class Strongspace.Views.Details extends Backbone.View
	
	initialize: ->
		dlog "init"

	afterRender: (view) ->

		$("#type").val(@serialize['session'].get("type"))
		
		if @serialize['session'].get('password') or @serialize['session'].get('id') == undefined or $("#password").val() != ""
			$("#save_password").prop('checked', true)

		if @serialize['session'].get('reconnectAtLogon') == true
			$("#reconnect_at_logon").prop('checked', true)
		
		if @serialize['session'].get("mountpoint")
			$("#mountpoint").val(@serialize['session'].get("mountpoint"))
		
		if @serialize['session'].get("authentication")
			$("#authentication").val(@serialize['session'].get("authentication"))
			
			if($("#authentication").val() != "password")
				$("#password").html("").prop("disabled", true)
			else
				$("#password").prop("disabled", null)

		if !$("#more_options").is(":visible") and Strongspace.Settings['more_options'] == true
			$("#more_options").show()
			$("#button_fewer_options").show()
			$("#button_more_options").hide()

		if @serialize['session'].get('status') == "connected" or @serialize['session'].get('status') == "connecting"
			$("#details input, #details select").prop('disabled', true)

		if settings.platform() == "mac"
			$(".platform_windows").remove()

		if settings.platform() == "windows"
			$(".platform_mac").remove()
			$("button").addClass("btn")



		@changeDriveType()

	events:
		"click #button_connect" : "connectSession"
		"click #button_delete" : "deleteSession"
		"click #button_reveal" : "revealSession"
		"click #button_eject" : "ejectSession"
		"click #button_add_favorite" : "addFavorite"
		"click #button_save" : "saveSession"
		"click #button_more_options" : "toggleMoreOptions"
		"click #button_fewer_options" : "toggleMoreOptions"
		"click #button_dropbox_oauth" : "dropboxOAuth"

		"keydown input" : "unhideSaveChanges"
		"change #type" : "changeDriveType"
		"change #mountpoint" : "unhideSaveChanges"
		"change #reconnect_at_logon" : "unhideSaveChanges"
		"change #save_password" : "unhideSaveChanges"
		"change #authentication" : "promptForKey"

	tagName: "div"

	id: "page_sessiondetails"


	unhideSaveChanges: (event) ->
		if !event.shiftKey and !event.altKey and !event.metaKey
			if not $("#button_add_favorite").is(":visible")
				$("#button_save").show(200)


	addFavorite: (event) ->
		event.preventDefault()
		
		if $("#server").val() == "" and $("#type").val() != "s3" and $("#type").val() != "dropbox"
			return

		session = new Strongspace.Models.Session()


		session.set('server', $("#server").val())

		session.set('remotePath', $("#remotePath").val())
		session.set('port', $("#port").val())
		session.set('name', $("#server").val())

		name = session.get('name')

		if name.split("://").length > 1
			l = @getLocation(name)
			session.set('name', l.hostname)
		
		if $("#type").val() == "s3"
			session.set("name", "Amazon S3")

		if $("#type").val() == "dreamobjects"
			session.set("name", "DreamObjects")

		if $("#type").val() == "dropbox"
			session.set("name", "Dropbox")

		if $("#type").val() == "cloudfiles"
			session.set("name", "Cloud Files")

		# if $("#type").val() == "webdav" and $("#server").val().split("://").length > 1
		# 	if $("#server").val().split("://")[1].split("/").length > 1
		# 		session.set("name", $("#server").val().split("://")[1].split("/")[0])
		# 	else
		# 		session.set("name", $("#server").val().split("://")[1])

		session.set('authentication', $("#authentication").val())

		if($("#authentication").val() == "publickey")
			session.set("private_key_file", @serialize['session'].get("private_key_file"))

		session.set('username', $("#username").val())
		session.set('type', $("#type").val())
		if $("#name").val()
			session.set('name', $("#name").val())
		session.set('mountpoint', $("#mountpoint").val())
		session.set('reconnectAtLogon', $("#reconnect_at_logon").prop('checked') == true)
		
		if $("#save_password").prop("checked") == true
			encrypted = keychain.save(@$("#server").val(), @$("#username").val(), @$("#password").val(), session.get("type"), session.get("port"))
			if encrypted and encrypted.length
				session.set('password', encrypted)
		else
			session.set('password', null)
			session.password = null
			$("#password").html("")

		session.save()

		Strongspace.SavedSessions.add(session)
		$("li.favorites").click()
		dlog "Add"
		Strongspace.List.selectSession(session.id)

	saveSession: (event) ->
		event.preventDefault()

		if $("#server").val() == "" and $("#type").val() != "s3" and $("#type").val() != "dropbox"
			return

		session = @serialize['session']

		session.set('server', $("#server").val())
		session.set('remotePath', $("#remotePath").val())
		session.set('port', $("#port").val())
		session.set('name', $("#server").val())
		
		if $("#type").val() == "s3"
			session.set("name", "Amazon S3")

		if $("#type").val() == "dreamobjects"
			session.set("name", "DreamObjects")
		
		if $("#type").val() == "dropbox"
			session.set("name", "Dropbox")

		if $("#type").val() == "cloudfiles"
			session.set("name", "Cloud Files")

		if $("#type").val() == "webdav" and $("#server").val().split("://").length > 1
			session.set("name", $("#server").val().split("://")[1])


		session.set('authentication', $("#authentication").val())
		session.set('username', $("#username").val())
		session.set('type', $("#type").val())
		if $("#name").val()
			@serialize['session'].set('name', $("#name").val())
		session.set('mountpoint', $("#mountpoint").val())
		session.set('reconnectAtLogon', $("#reconnect_at_logon").prop('checked') == true)

		if $("#save_password").prop("checked") == true
			encrypted = keychain.save(@$("#server").val(), @$("#username").val(), @$("#password").val(), session.get("type"), session.get("port"))
			if encrypted and encrypted.length
				session.set('password', encrypted)
		else
			session.set('password', null)
			session.password = null
			$("#password").html("")

		session.save()
		Strongspace.List.render()
		Strongspace.List.selectSession(session.id)

	revealSession: (event) ->
		event.preventDefault()
		@serialize['session'].reveal()

	ejectSession: (event) ->
		event.preventDefault()
		@serialize['session'].eject()

	connectSession: (event) ->
		event.preventDefault()

		if @serialize['session'].id == undefined or @serialize['session'].id.length == 0
			@addFavorite(event)

		@serialize['session'].start()

	deleteSession: (event) ->
		event.preventDefault()
		session = @serialize['session']
		session.stop()
		Strongspace.SavedSessions.remove(session)
		session.destroy()
		Strongspace.List.render()


	toggleMoreOptions: (event) ->
		dlog Strongspace.Settings['more_options']
		Strongspace.Settings['more_options'] = !Strongspace.Settings['more_options']
		$("#more_options").toggle(200)
		$("#button_fewer_options").toggle()
		$("#button_more_options").toggle()

	promptForKey: (event) ->
		@unhideSaveChanges(event)
		if $("#authentication").val() == "publickey"
			expandrive.keyPrompt("key", "Please select your private key")
			$("#password").html("").prop("disabled", true)
			@serialize['session'].set('private_key_file', expandrive.privateKeyData())
		else if $("#authentication").val() == "password"
			$("#password").prop("disabled", null)


	dropboxOAuth: (event) ->
		event.preventDefault()
		self = @


		$.ajax
			url: "https://api.dropbox.com/1/oauth/request_token"
			type: "POST"
			beforeSend: (xhr) ->
				xhr.setRequestHeader "Authorization", 'OAuth oauth_version="1.0", oauth_signature_method="PLAINTEXT", oauth_consumer_key="jwomlqtdhz8bhyd", oauth_signature="7gwc0yc18xc68qt&"'
				data: {}

			success: (data) ->
				request_secret = data.split("&")[0]
				request_token = data.split("&")[1]
				self.request_secret = request_secret.split("oauth_token_secret=")[1]
				self.request_token = request_token.split("oauth_token=")[1]

				url = "https://www.dropbox.com/1/oauth/authorize?oauth_token=#{self.request_token}"
				$("#button_dropbox_oauth").html("Waiting for you to authorize ExpanDrive..").prop('disabled', "true")
				keychain.openOAuthURL(url)

				setTimeout ( ->
					self.dropboxOauth2()
				), 2000



	dropboxOauth2: () ->
		self = @
		access_token_url = "https://api.dropbox.com/1/oauth/access_token"

		auth_header = "OAuth oauth_version=\"1.0\", oauth_signature_method=\"PLAINTEXT\", oauth_consumer_key=\"jwomlqtdhz8bhyd\", oauth_token=\"#{self.request_token}\", oauth_signature=\"7gwc0yc18xc68qt&#{self.request_secret}\""

		
		$.ajax
			url: access_token_url
			type: "POST"
			beforeSend: (xhr) ->
				xhr.setRequestHeader "Authorization", auth_header
				data: {}

			success: (data) ->

				access_secret = data.split("&")[0]
				access_token = data.split("&")[1]

				self.access_secret = access_secret.split("oauth_token_secret=")[1]
				self.access_token = access_token.split("oauth_token=")[1]
				
				$("#username").val(self.access_token)
				$("#password").val(self.access_secret)

				self.dropboxAccountInfo()

			error: (a, b) ->
				setTimeout ( ->
					self.dropboxOauth2()
				), 2000


	dropboxAccountInfo: () ->
		self = @		
		account_url = "https://api.dropbox.com/1/account/info"
		auth_header = "OAuth oauth_version=\"1.0\", oauth_signature_method=\"PLAINTEXT\", oauth_consumer_key=\"jwomlqtdhz8bhyd\", oauth_token=\"#{self.access_token}\", oauth_signature=\"7gwc0yc18xc68qt&#{self.access_secret}\""

		$.ajax
			url: account_url
			type: "GET"
			dataType: "json"
			beforeSend: (xhr) ->
				xhr.setRequestHeader "Authorization", auth_header
				data: {}
			success: (data) ->
				$(".dropbox_attributes .notauthorized").hide()
				$(".dropbox_attributes .authorized").show()
				$(".buttonbar").show()
				$("#dropbox_account").html(data['display_name'] + "'s Dropbox<br>" + data['email'])
				name_element = $("#name").parents(".control-group").detach()
				$(".dropbox_attributes").append(name_element)
				mountpoint_element = $("#mountpoint").parents(".control-group").detach()
				$(".dropbox_attributes").append(mountpoint_element)

	getLocation: (href) ->
		if not href.split("://").length > 1
			href = "http://" + href
		l = document.createElement("a")
		l.href = href
		return l

	changeDriveType: (event) ->
		self = @
		$("label", $("#username").parents(".control-group") ).html("Username:")
		$("label", $("#password").parents(".control-group") ).html("Password:")
		$("#port").parents(".control-group").show()
		$("#authentication").parents(".control-group").show()

		if @serialize['session'].get('status') != "connected" and @serialize['session'].get('status') != "connecting"
			$("#server").prop("disabled", false)
		$("#server").attr("placeholder", null)
		#$("#server").val("")


		if($("#type").val() == "sftp")
			$("#port").attr("placeholder", 22)

		if($("#type").val() == "ftp")
			$("#port").attr("placeholder", 21)
			$("#authentication").parents(".control-group").hide()

		if($("#type").val() == "s3" or $("#type").val() == "dreamobjects" or $("#type").val() == "cloudfiles")
			server_element = $("#server").parents(".control-group").detach()
			$("#more_options").prepend(server_element)
		else
			server_element = $("#server").parents(".control-group").detach()
			drive_type_block = $("#type").parents(".control-group")
			$(".regular_attributes.basic").prepend(server_element)

		if($("#type").val() == "s3" or $("#type").val() == "dreamobjects" or $("#type").val() == "cloudfiles" or $("#type").val() == "swift" or $("#type").val() == "webdav")
			
			if($("#type").val() == "s3")
				$("#server").attr("placeholder", "s3.amazonaws.com")

			if $("#type").val() != "webdav"
				$("label", $("#username").parents(".control-group") ).html("Access ID:")
				$("label", $("#password").parents(".control-group") ).html("Secret Key:")
			else
				$("#server").attr("placeholder", "https://yourserver.com/dav")

			$("#password").attr('placeholder', '')
			$("#port").parents(".control-group").hide()
			$("#authentication").parents(".control-group").hide()

	
		if($("#type").val() == "dreamobjects")
			$("#server").val("objects.dreamhost.com").prop("disabled", true)

		if($("#type").val() == "cloudfiles")
			$("#server").val("identity.api.rackspacecloud.com/v1.0")


		if($("#type").val() == "dropbox")

			$("#server").val("dropbox.com")
			$(".regular_attributes").hide()
			$(".dropbox_attributes").show()

			if($("#username").val() == "")
				$(".buttonbar").hide()
				$(".dropbox_attributes .notauthorized").show()
				$(".dropbox_attributes .authorized").hide()
			else
				$(".dropbox_attributes .notauthorized").hide()
				$(".dropbox_attributes .authorized").show()
				name_element = $("#name").parents(".control-group").detach()
				$(".dropbox_attributes").append(name_element)
				mountpoint_element = $("#mountpoint").parents(".control-group").detach()
				$(".dropbox_attributes").append(mountpoint_element)

				self.access_token = $("#username").val()

				self.access_secret = $("#password").val()

				setTimeout ( ->
					self.dropboxAccountInfo()
				), 10
				


			
		else
			$(".regular_attributes").show()
			$(".buttonbar").show()
			$(".dropbox_attributes").hide()


