class Strongspace.Views.List extends Backbone.View

	initialize: ->
		@collection = new Strongspace.Collections.Sessions()
		Strongspace.SavedSessions = @collection
		@collection.sync = Strongspace.SessionSync
		
		@details = new Strongspace.Views.Details(template: "details")
		
		@collection.on("add", @yell, @)
		@collection.on("changed", @yell, @)
		@collection.on("reset", @yell, @)

		@collection.fetch()

		
		@insertView("#details", @details);
		Strongspace.Details = @details
		if @collection.length
			@details.serialize = {session: @collection.at(0)}
		else
			@details.serialize = {session: new Strongspace.Models.Session()}
			@newSession()

		

		self = @
		@on("afterRender", (view) ->
			if self.collection.length == 0
				$("li.new").click()
				return
			# dlog "After render"
			if Strongspace.Settings['selected'] == null or Strongspace.Settings['selected'] == undefined or self.collection.get(Strongspace.Settings['selected']) == undefined
				self.selectSession(self.collection.at(0).id)
			else
				self.selectSession(self.collection.get(Strongspace.Settings['selected']).id)
		)



	events:
		"click li.session": "clickSession"
		"click li.connected div.eject": "ejectSession"
		"click li.connected div.reveal": "revealSession"
		"dblclick li.session": "dblclickSession"


	yell: ->
		@render()

	getTargetId: (e) ->
		row = $(e.target) 
		id = row.attr('id')
		
		if id == undefined
			row = $(e.target).parents(".session")
			id = row.attr('id')

		return id

	clickSession: (e) ->
		id = @getTargetId(e)
		@selectSession(id)

	ejectSession: (e) ->
		id = @getTargetId(e)
		@collection.get(id).eject()

	revealSession: (e) ->
		id = @getTargetId(e)
		@collection.get(id).reveal()

	selectSession: (id) ->
		Strongspace.Settings['selected'] = id
		$("#sessions li").removeClass("selected")
		row = $("#" + id)
		row.addClass("selected")
		@details.serialize = {session: @collection.get(id)}
		@details.render()


	dblclickSession: (e) ->

		id = @getTargetId(e)
		#Strongspace.removeSession(id)
		if $("#" + id).hasClass("connected")
			@collection.get(id).reveal()
		else
			@collection.get(id).start()

	newSession: ->
		@details.serialize = {session: new Strongspace.Models.Session()}

		@details.render()

		settings.setWindowTitle("New Drive")

		$("#details").show()
		@$("#button_add_favorite").show()


		$("#details").animate(
			left: $("#sidebar").width() + 1
			opacity: 1.0
		, 100)

		$("#settings").animate(
			left: -1500
			right: 1500
		, 100)
		$("#server").focus()

	showFavorites: ->
		if Strongspace.SavedSessions.length == 0
			$("#details").hide()

		settings.setWindowTitle("Drives")

		$("#button_add_favorite").hide(200)
		$("#details").animate(
			left: $("#list").width() + $("#sidebar").width() + 2
		, 100)
		$("#settings").animate(
			left: -1500
			right: 1500
		, 100)
		$("li.session.selected").click()

	showSettings: ->
		settings.setWindowTitle("Settings")
		$("#settings").animate(
			left: $("#sidebar").width()
			right: 0
		, 100)

	serialize: ->
	    return { sessions: @collection.models }