class Properties.Views.Main extends Backbone.View
	
	initialize: ->
		@render()
		

	events:
		"click input[type=\"checkbox\"]" : "clickCheckBox"
		"click #apply" : "applyChanges"
		"change #s3_acl" : "changeS3ACL"

	clickCheckBox: () ->
		octal = ""
		text = ""

		$("#apply").prop('disabled', null)
		
		for id in ["#user", "#group", "#other"]
			bin = ""
			if $(id + "_read").prop('checked')
				text += "r"
				bin += "1"
			else
				text += "-"
				bin += "0"

			if $(id + "_write").prop('checked')
				text += "w"
				bin += "1"
			else
				text += "-"
				bin += "0"

			if $(id + "_execute").prop('checked')
				text += "x"
				bin += "1"
			else
				text += "-"
				bin += "0"
			octal += parseInt(bin, 2)

		$("#mode").html(octal)

	changeS3ACL: () ->
		if $("#mode").val() != "complex"
			$("#apply").prop('disabled', null)
			$("#complex_acl", this.$el).remove()


	applyChanges: () ->
		$("#apply").prop('disabled', true)
		# s3 path
		if $("#mode").html() == undefined
			expandrive.chmod($("#s3_acl").val(), window.expandrive_file_path)
		else
			expandrive.chmod($("#mode").html(), window.expandrive_file_path)

	render: ->
		template_html = new window.EJS {url: 'javascripts/templates/properties_' + window.expandrive_driveType + '.ejs'}
	
		this.$el.empty()
		this.$el.append(template_html.render(session: @model))

		components = window.expandrive_file_mode.split("")

		for index, id of ["#user", "#group", "#other"]
			if components[index] == "7" or components[index] == "6" or components[index] == "5" or components[index] == "4"
				$(id + "_read", this.$el).prop("checked", true)
			if components[index] == "7" or components[index] == "5" or components[index] == "3" or components[index] == "2"
				$(id + "_execute", this.$el).prop("checked", true)
			if components[index] == "7" or components[index] == "6" or components[index] == "3" or components[index] == "2"
				$(id + "_write", this.$el).prop("checked", true)

		if window.expandrive_s3_acl != "complex"
			$("#complex_acl", this.$el).remove()
		
		$("#s3_acl", this.$el).val(window.expandrive_s3_acl)

		